ArchiveResource (Apache Ant API)
Description: declaration: package: org.apache.tools.ant.types.resources, class: ArchiveResource

# Class ArchiveResource

java.lang.Object
org.apache.tools.ant.ProjectComponent
org.apache.tools.ant.types.DataType
org.apache.tools.ant.types.Resource
org.apache.tools.ant.types.resources.ArchiveResource

All Implemented Interfaces:
  `Cloneable, Comparable<Resource>, Iterable<Resource>, ResourceCollection`

Direct Known Subclasses:
  `TarResource, ZipResource`

public abstract class ArchiveResource extends Resource
A Resource representation of an entry inside an archive.

Since:
  Ant 1.7

- ## Field Summary

  ### Fields inherited from class Resource

  `MAGIC, UNKNOWN_DATETIME, UNKNOWN_SIZE`
  Modifier and Type
  Field
  Description
  `protected static final int`
  `MAGIC`
  Magic number
  `static final long`
  `UNKNOWN_DATETIME`
  Constant unknown datetime for getLastModified
  `static final long`
  `UNKNOWN_SIZE`
  Constant unknown size

  ### Fields inherited from class DataType

  `checked, ref`
  Modifier and Type
  Field
  Description
  `protected boolean`
  `checked`
  Deprecated.
  since 1.7.
  `protected Reference`
  `ref`
  Deprecated.
  since 1.7.

  ### Fields inherited from class ProjectComponent

  `description, location, project`
  Modifier and Type
  Field
  Description
  `protected String`
  `description`
  Deprecated.
  since 1.6.x.
  `protected Location`
  `location`
  Deprecated.
  since 1.6.x.
  `protected Project`
  `project`
  Deprecated.
  since 1.6.x.

- ## Constructor Summary

  Constructors
  Modifier
  Constructor
  Description
  `protected`
  `ArchiveResource()`
  Default constructor.
  `protected`
  `ArchiveResource(File a)`
  Construct a ArchiveResource representing the specified entry in the specified archive.
  `protected`
  `ArchiveResource(File a, boolean withEntry)`
  Construct a ArchiveResource representing the specified entry in the specified archive.
  `protected`
  `ArchiveResource(Resource a, boolean withEntry)`
  Construct a ArchiveResource representing the specified entry in the specified archive.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `addConfigured(ResourceCollection a)`
  Sets the archive that holds this as a single element Resource collection.
  `protected final void`
  `checkEntry()`
  Validate settings and ensure that the represented "archive entry" has been established.
  `int`
  `compareTo(Resource another)`
  Compare this ArchiveResource to another Resource.
  `protected void`
  `dieOnCircularReference(Stack<Object> stk, Project p)`
  Check to see whether any DataType we hold references to is included in the Stack (which holds all DataType instances that directly or indirectly reference this instance, including this instance itself).
  `boolean`
  `equals(Object another)`
  Compare another Object to this ArchiveResource for equality.
  `protected abstract void`
  `fetchEntry()`
  Fetch information from the named entry inside the archive.
  `Resource`
  `getArchive()`
  Get the archive that holds this Resource.
  `long`
  `getLastModified()`
  Get the last modified date of this Resource.
  `int`
  `getMode()`
  Get the file or dir mode for this Resource.
  `protected ArchiveResource`
  `getRef()`
  Perform the check for circular references and return the referenced Resource.
  `long`
  `getSize()`
  Get the size of this Resource.
  `int`
  `hashCode()`
  Get the hash code for this Resource.
  `boolean`
  `isDirectory()`
  Learn whether this Resource represents a directory.
  `boolean`
  `isExists()`
  Find out whether this Resource represents an existing Resource.
  `void`
  `setArchive(File a)`
  Set the archive that holds this Resource.
  `void`
  `setMode(int mode)`
  Sets the file or dir mode for this resource.
  `void`
  `setRefid(Reference r)`
  Overrides the super version.
  `String`
  `toString()`
  Format this Resource as a String.

  ### Methods inherited from class Resource

  `as, asOptional, clone, getInputStream, getMagicNumber, getName, getOutputStream, isFilesystemOnly, iterator, setDirectory, setExists, setLastModified, setName, setSize, size, toLongString`
  Modifier and Type
  Method
  Description
  `<T> T`
  `as(Class<T> clazz)`
  Returns a view of this resource that implements the interface given as the argument or null if there is no such view.
  `<T> Optional<T>`
  `asOptional(Class<T> clazz)`
  Return `Resource.as(Class)` as an `Optional`.
  `Object`
  `clone()`
  Clone this Resource.
  `InputStream`
  `getInputStream()`
  Get an InputStream for the Resource.
  `protected static int`
  `getMagicNumber(byte[] seed)`
  Create a "magic number" for use in hashCode calculations.
  `String`
  `getName()`
  Name attribute will contain the path of a file relative to the root directory of its fileset or the recorded path of a zip entry.
  `OutputStream`
  `getOutputStream()`
  Get an OutputStream for the Resource.
  `boolean`
  `isFilesystemOnly()`
  Fulfill the ResourceCollection contract.
  `Iterator<Resource>`
  `iterator()`
  Fulfill the ResourceCollection contract.
  `void`
  `setDirectory(boolean directory)`
  Set the directory attribute.
  `void`
  `setExists(boolean exists)`
  Set the exists attribute.
  `void`
  `setLastModified(long lastmodified)`
  Set the last modification attribute.
  `void`
  `setName(String name)`
  Set the name of this Resource.
  `void`
  `setSize(long size)`
  Set the size of this Resource.
  `int`
  `size()`
  Fulfill the ResourceCollection contract.
  `final String`
  `toLongString()`
  Get a long String representation of this Resource.

  ### Methods inherited from class DataType

  `checkAttributesAllowed, checkChildrenAllowed, circularReference, dieOnCircularReference, dieOnCircularReference, getCheckedRef, getCheckedRef, getCheckedRef, getCheckedRef, getCheckedRef, getDataTypeName, getRefid, invokeCircularReferenceCheck, isChecked, isReference, noChildrenAllowed, pushAndInvokeCircularReferenceCheck, setChecked, tooManyAttributes`
  Modifier and Type
  Method
  Description
  `protected void`
  `checkAttributesAllowed()`
  check that it is ok to set attributes, i.e that no reference is defined
  `protected void`
  `checkChildrenAllowed()`
  check that it is ok to add children, i.e that no reference is defined
  `protected BuildException`
  `circularReference()`
  Creates an exception that indicates the user has generated a loop of data types referencing each other.
  `protected void`
  `dieOnCircularReference()`
  Convenience method.
  `protected void`
  `dieOnCircularReference(Project p)`
  Convenience method.
  `protected <T> T`
  `getCheckedRef()`
  Deprecated.
  use getCheckedRef(Class)
  `protected <T> T`
  `getCheckedRef(Class<T> requiredClass)`
  Performs the check for circular references and returns the referenced object.
  `protected <T> T`
  `getCheckedRef(Class<T> requiredClass, String dataTypeName)`
  Performs the check for circular references and returns the referenced object.
  `protected <T> T`
  `getCheckedRef(Class<T> requiredClass, String dataTypeName, Project project)`
  Performs the check for circular references and returns the referenced object.
  `protected <T> T`
  `getCheckedRef(Project p)`
  Deprecated.
  use getCheckedRef(Class)
  `protected String`
  `getDataTypeName()`
  Gets as descriptive as possible a name used for this datatype instance.
  `Reference`
  `getRefid()`
  get the reference set on this object
  `static void`
  `invokeCircularReferenceCheck(DataType dt, Stack<Object> stk, Project p)`
  Allow DataTypes outside org.apache.tools.ant.types to indirectly call dieOnCircularReference on nested DataTypes.
  `protected boolean`
  `isChecked()`
  The flag that is used to indicate that circular references have been checked.
  `boolean`
  `isReference()`
  Has the refid attribute of this element been set?
  `protected BuildException`
  `noChildrenAllowed()`
  Creates an exception that indicates that this XML element must not have child elements if the refid attribute is set.
  `static void`
  `pushAndInvokeCircularReferenceCheck(DataType dt, Stack<Object> stk, Project p)`
  Allow DataTypes outside org.apache.tools.ant.types to indirectly call dieOnCircularReference on nested DataTypes.
  `protected void`
  `setChecked(boolean checked)`
  Set the flag that is used to indicate that circular references have been checked.
  `protected BuildException`
  `tooManyAttributes()`
  Creates an exception that indicates that refid has to be the only attribute if it is set.

  ### Methods inherited from class ProjectComponent

  `getDescription, getLocation, getProject, log, log, setDescription, setLocation, setProject`
  Modifier and Type
  Method
  Description
  `String`
  `getDescription()`
  Returns the description of the current action.
  `Location`
  `getLocation()`
  Returns the file/location where this task was defined.
  `Project`
  `getProject()`
  Returns the project to which this component belongs.
  `void`
  `log(String msg)`
  Logs a message with the default (INFO) priority.
  `void`
  `log(String msg, int msgLevel)`
  Logs a message with the given priority.
  `void`
  `setDescription(String desc)`
  Sets a description of the current action.
  `void`
  `setLocation(Location location)`
  Sets the file/location where this task was defined.
  `void`
  `setProject(Project project)`
  Sets the project object of this component.

  ### Methods inherited from class Object

  `finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface Iterable

  `forEach, spliterator`

  ### Methods inherited from interface ResourceCollection

  `isEmpty, stream`
  Modifier and Type
  Method
  Description
  `default boolean`
  `isEmpty()`
  Learn whether this `ResourceCollection` is empty.
  `default Stream<? extends Resource>`
  `stream()`
  Return a `Stream` over this `ResourceCollection`.

- ## Constructor Details

  - ### ArchiveResource

    protected ArchiveResource()
    Default constructor.

  - ### ArchiveResource

    protected ArchiveResource(File a)
    Construct a ArchiveResource representing the specified entry in the specified archive.
    Parameters:
      `a` - the archive as File.

  - ### ArchiveResource

    protected ArchiveResource(File a, boolean withEntry)
    Construct a ArchiveResource representing the specified entry in the specified archive.
    Parameters:
      `a` - the archive as File.
      `withEntry` - if the entry has been specified.

  - ### ArchiveResource

    protected ArchiveResource(Resource a, boolean withEntry)
    Construct a ArchiveResource representing the specified entry in the specified archive.
    Parameters:
      `a` - the archive as Resource.
      `withEntry` - if the entry has been specified.

- ## Method Details

  - ### setArchive

    public void setArchive(File a)
    Set the archive that holds this Resource.
    Parameters:
      `a` - the archive as a File.

  - ### setMode

    public void setMode(int mode)
    Sets the file or dir mode for this resource.
    Parameters:
      `mode` - integer representation of Unix permission mask.

  - ### addConfigured

    public void addConfigured(ResourceCollection a)
    Sets the archive that holds this as a single element Resource collection.
    Parameters:
      `a` - the archive as a single element Resource collection.

  - ### getArchive

    public Resource getArchive()
    Get the archive that holds this Resource.
    Returns:
      the archive as a Resource.

  - ### getLastModified

    public long getLastModified()
    Get the last modified date of this Resource.
    Overrides:
      `getLastModified` in class `Resource`
    Returns:
      the last modification date.

  - ### getSize

    public long getSize()
    Get the size of this Resource.
    Overrides:
      `getSize` in class `Resource`
    Returns:
      the long size of this Resource.

  - ### isDirectory

    public boolean isDirectory()
    Learn whether this Resource represents a directory.
    Overrides:
      `isDirectory` in class `Resource`
    Returns:
      boolean flag indicating whether the entry is a directory.

  - ### isExists

    public boolean isExists()
    Find out whether this Resource represents an existing Resource.
    Overrides:
      `isExists` in class `Resource`
    Returns:
      boolean existence flag.

  - ### getMode

    public int getMode()
    Get the file or dir mode for this Resource.
    Returns:
      integer representation of Unix permission mask.

  - ### setRefid

    public void setRefid(Reference r)
    Overrides the super version.
    Overrides:
      `setRefid` in class `Resource`
    Parameters:
      `r` - the Reference to set.

  - ### compareTo

    public int compareTo(Resource another)
    Compare this ArchiveResource to another Resource.
    Specified by:
      `compareTo` in interface `Comparable<Resource>`
    Overrides:
      `compareTo` in class `Resource`
    Parameters:
      `another` - the other Resource against which to compare.
    Returns:
      a negative integer, zero, or a positive integer as this Resource is less than, equal to, or greater than the specified Resource.

  - ### equals

    public boolean equals(Object another)
    Compare another Object to this ArchiveResource for equality.
    Overrides:
      `equals` in class `Resource`
    Parameters:
      `another` - the other Object to compare.
    Returns:
      true if another is a Resource representing the same entry in the same archive.

  - ### hashCode

    public int hashCode()
    Get the hash code for this Resource.
    Overrides:
      `hashCode` in class `Resource`
    Returns:
      hash code as int.

  - ### toString

    public String toString()
    Format this Resource as a String.
    Overrides:
      `toString` in class `Resource`
    Returns:
      String representation of this Resource.

  - ### checkEntry

    protected final void checkEntry() throws BuildException
    Validate settings and ensure that the represented "archive entry" has been established.
    Throws:
      `BuildException`

  - ### fetchEntry

    protected abstract void fetchEntry()
    Fetch information from the named entry inside the archive.

  - ### dieOnCircularReference

    protected void dieOnCircularReference(Stack<Object> stk, Project p)
    Check to see whether any DataType we hold references to is included in the Stack (which holds all DataType instances that directly or indirectly reference this instance, including this instance itself).

    If one is included, throw a BuildException created by `circularReference`.

    This implementation is appropriate only for a DataType that cannot hold other DataTypes as children.

    The general contract of this method is that it shouldn't do anything if `DataType.checked` is true and set it to true on exit.

    Overrides:
      `dieOnCircularReference` in class `DataType`
    Parameters:
      `stk` - the stack of references to check.
      `p` - the project to use to dereference the references.

  - ### getRef

    protected ArchiveResource getRef()
    Description copied from class: `Resource`
    Perform the check for circular references and return the referenced Resource.
    Overrides:
      `getRef` in class `Resource`
    Returns:
      `Resource`.